package slydez;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.Component;
import java.awt.Container;
import javax.swing.JComponent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;

public class Shapes {
    
    //Global Variables
    public String shapeType;
    public int xCordStart;//=0;
    public int yCordStart;//=0;
    public int xCordEnd;//=0;
    public int yCordEnd;//=0;
    public int width=0;
    public int height=0;
    public int arc=20;
    
    //public int diameter=0;
    public double centerX=0;
    public double centerY=0;
    
    Color lineColor = new Color(1,0,0); //Default line color is black
    Color fillColor = new Color(245,246,246); //Default fill color is light grey

    public boolean AvailabilityStatus;
    public boolean ObjectSelected=false; //true if object is selected
    public boolean saved=false; //true if shape is saved in text file, false otherwise
    
    //Determine if the shape has been drawn
    boolean drawn;
    
    public String shapeID; // unique identification of the shape (username+shapeCount)   
    public String username=null; //used to determine which user has currently locked the selected shape  
    public boolean lock=false; //locked if shape has been selected by a user  
    
    /** Creates a new instance of ObjectShape */
    public Shapes(){
    }
    
 
     public Shapes(String t, int x, int y, int w, int h){ //String Type) {
		shapeType =t;
		xCordStart = x;
		yCordStart = y;
		width = w;
		height = h;
    }
       
    //********************************GETTERS****************************************//
    
    public String getShapeType(){
        return shapeType;
    }
    
    public int getXCordStart() {
        return xCordStart;
    }
    
    public int getYCordStart() {
        return yCordStart;
    }
    
    public int getXCordEnd() {
        return xCordEnd;
    }
    
    public int getYCordEnd() {
        return yCordEnd;
    }
    
    public int getWidth(){
        return width;
    }
    
    public int getHeight(){
        return height;
    }
    
    public int getArc(){
        return arc;
    }
    
    public Color getLineColor(){
        return lineColor;
    }
    
    public Color getFillColor(){
        return fillColor;
    }
    
    public boolean getObjectSelected(){
        return ObjectSelected;
    }
    
    public double getCenterX(){
        return centerX;
    }
    
    public double getCenterY(){
        return centerY;
    }
    
    public boolean getSaved(){
        return saved;
    }
    
  
    public boolean getLock(){
        return lock;
    }
    

    public String getShapeID(){
        return shapeID;
    }
    

    public String getUsername(){
        return username;
    }
    
    //
    //********************************SETTERS****************************************//
	
    public void setShapeType(String s){
        shapeType = s;
    }
       
    public void setStartCoordinates(int x, int y){
       xCordStart = x;
       yCordStart = y;
    }
    
     public void setEndCoordinates(int x, int y){
       xCordEnd = x;
       yCordEnd = y;
    }
     
    public void setWidthHeight(int w, int h){
        width = w;
        height = h;
    }
    
    public void setArc(int a){
        arc=a;
    }
   
    public void setLineColor(Color LC){
        lineColor = LC;
    }
    
    public void setfillColor(Color FC){
        fillColor = FC;
    }
    
    public void setObjectSelected(boolean b){
        ObjectSelected=b;
       
        //if a shape has been selected the shape is also locked 
        if(ObjectSelected){
            lock=true;
        }else{
            lock=false;
        }
    }
    
    public void setCenterX(double x){
        centerX = x;
    }
    
    public void setCenterY(double y){
        centerY = y;
    }
    
    public void setSaved(boolean b){
        saved = b;
    }
    
   
    public void setLock(boolean b) {
        lock=b;
    }
    
   
    public void setShapeID(String id){
        shapeID = id;
    }
    
   
    public void setUsername(String name){
        username = name;
    }
    
    
    //********************************Methods****************************************//
    

    public String convertToString(Shapes shape){
        String message;
        
       if (shape.getShapeType().equals("Ellipse")){     
            //Return String representation of Ellipse in following format "type:x-cord:y-cord:width:height:line-color:fill-color"
            int x = shape.getXCordStart();
            int y = shape.getYCordStart();
            int w = shape.getWidth();
            int h = shape.getHeight();
            int lineRed = (shape.getLineColor()).getRed();
            int lineGreen = (shape.getLineColor()).getGreen();
            int lineBlue = (shape.getLineColor()).getBlue();
            int fillRed = (shape.getFillColor()).getRed();
            int fillGreen = (shape.getFillColor()).getGreen();
            int fillBlue = (shape.getFillColor()).getBlue();
            boolean selected = shape.getObjectSelected();
            //Do the boolean to String conversion
            String s = new Boolean(selected).toString(); //determine if shape is selected
            String id = shape.getShapeID();
            String name = shape.getUsername();
            String locked = new Boolean(shape.getLock()).toString();
            //format: shape type:x1:y1:width:height:lineRed:lineGreen:lineBlue:fillReg:fillGreen:fillBlue:selected:shapeId:Locked
            message = ("Ellipse" + ":" + x + ":" + y + ":" + w + ":" + h + ":" + lineRed + ":" + lineGreen + ":" + lineBlue + ":" + fillRed + ":" + fillGreen + ":" + fillBlue + ":" + s + ":" + id + ":" + locked + ":" + name + "%");
            
            System.out.println(message); //testing
            System.out.println("Convert Ellipse to string"); //testing
            return message;
       } else if (shape.getShapeType().equals("Circle")){
            //Return String representation of Cirlce in following format "type:x-cord:y-cord:width:height:line-color:fill-color"
            int x = shape.getXCordStart();
            int y = shape.getYCordStart();
            int w = shape.getWidth();
            int lineRed = (shape.getLineColor()).getRed();
            int lineGreen = (shape.getLineColor()).getGreen();
            int lineBlue = (shape.getLineColor()).getBlue();
            int fillRed = (shape.getFillColor()).getRed();
            int fillGreen = (shape.getFillColor()).getGreen();
            int fillBlue = (shape.getFillColor()).getBlue();
            boolean selected = shape.getObjectSelected();
            //Do the boolean to String conversion
            String s = new Boolean(selected).toString();
            String id = shape.getShapeID();
            String name = shape.getUsername();
            String locked = new Boolean(shape.getLock()).toString();
            
            message = ("Circle" + ":" + x + ":" + y + ":" + w + ":" + w + ":" + lineRed + ":" + lineGreen + ":" + lineBlue + ":" + fillRed + ":" + fillGreen + ":" + fillBlue + ":" + s + ":" + id + ":" + locked + ":" + name + "%");
            System.out.println("Convert Circle to string"); //testing
            return message;      
       } else if (shape.getShapeType().equals("Line")){
            //Return String representation of Line in following format "type:xstart:ystart:xend:yend:line-color:fill-color"       
            int x1 = shape.getXCordStart();
            int y1 = shape.getYCordStart();
            int x2 = shape.getXCordEnd();
            int y2 = shape.getYCordEnd();     
            int lineRed = (shape.getLineColor()).getRed();
            int lineGreen = (shape.getLineColor()).getGreen();
            int lineBlue = (shape.getLineColor()).getBlue();
            boolean selected = shape.getObjectSelected();
            //Do the boolean to String conversion
            String s = new Boolean(selected).toString();
            String id = shape.getShapeID();
            String name = shape.getUsername();
            String locked = new Boolean(shape.getLock()).toString();
            
            message = ("Line" + ":" + x1 + ":" + y1 + ":" + x2 + ":" + y2 + ":" + lineRed + ":" + lineGreen + ":" + lineBlue + ":" + s + ":" + id + ":" + locked + ":" + name + "%");
            System.out.println("Convert Line to string"); //testing
            return message;     
       } else if (shape.getShapeType().equals("Arrow")){
            //Return String representation of Arrow in following format "type:x-cord:y-cord:width:height:line-color:fill-color"
            int x1 = shape.getXCordStart();
            int y1 = shape.getYCordStart();
            int x2 = shape.getXCordEnd();
            int y2 = shape.getYCordEnd();   
            int lineRed = (shape.getLineColor()).getRed();
            int lineGreen = (shape.getLineColor()).getGreen();
            int lineBlue = (shape.getLineColor()).getBlue();
            boolean selected = shape.getObjectSelected();
            //Do the boolean to String conversion
            String s = new Boolean(selected).toString();
            String id = shape.getShapeID();
            String name = shape.getUsername();
            String locked = new Boolean(shape.getLock()).toString();
            
            message = ("Arrow" + ":" + x1 + ":" + y1 + ":" + x2 + ":" + y2 + ":" + lineRed + ":" + lineGreen + ":" + lineBlue + ":" + s + ":" + id + ":" + locked + ":" + name + "%");   
            System.out.println("Convert Arrow to string"); //testing
            return message;             
       } else if (shape.getShapeType().equals("Rectangle")){
            //Return String representation of Rectangle in following format "type:x-cord:y-cord:width:height:line-color:fill-color"       
            int x = shape.getXCordStart();
            int y = shape.getYCordStart();
            int w = shape.getWidth();
            int h = shape.getHeight(); 
            int lineRed = (shape.getLineColor()).getRed();
            int lineGreen = (shape.getLineColor()).getGreen();
            int lineBlue = (shape.getLineColor()).getBlue();
            int fillRed = (shape.getFillColor()).getRed();
            int fillGreen = (shape.getFillColor()).getGreen();
            int fillBlue = (shape.getFillColor()).getBlue();
            boolean selected = shape.getObjectSelected();
            //Do the boolean to String conversion
            String s = new Boolean(selected).toString();
            String id = shape.getShapeID();
            String name = shape.getUsername();
            String locked = new Boolean(shape.getLock()).toString();
            
            message = ("Rectangle" + ":" + x + ":" + y + ":" + w + ":" + h + ":" + lineRed + ":" + lineGreen + ":" + lineBlue + ":" + fillRed + ":" + fillGreen + ":" + fillBlue + ":" + s + ":" + id + ":" + locked + ":" + name + "%");
            System.out.println("Convert Rectangle to string"); //testing
            return message;          
       } else {//if (shape.getShapeType()=="Round Rectangle"){
            //Return String representation of Round Rectangle in following format "type:x-cord:y-cord:width:height:line-color:fill-color"    
            int x = shape.getXCordStart();
            int y = shape.getYCordStart();
            int w = shape.getWidth();
            int h = shape.getHeight(); 
            int lineRed = (shape.getLineColor()).getRed();
            int lineGreen = (shape.getLineColor()).getGreen();
            int lineBlue = (shape.getLineColor()).getBlue();
            int fillRed = (shape.getFillColor()).getRed();
            int fillGreen = (shape.getFillColor()).getGreen();
            int fillBlue = (shape.getFillColor()).getBlue();
            boolean selected = shape.getObjectSelected();
            //Do the boolean to String conversion
            String s = new Boolean(selected).toString();
            String id = shape.getShapeID();
            String name = shape.getUsername();
            String locked = new Boolean(shape.getLock()).toString();
            
            message = ("Round Rectangle" + ":" + x + ":" + y + ":" + w + ":" + h + ":" + lineRed + ":" + lineGreen + ":" + lineBlue + ":" + fillRed + ":" + fillGreen + ":" + fillBlue + ":" + s + ":" + id + ":" + locked + ":" + name + "%");
            System.out.println("Convert Round Rectangle to string"); //testing
            return message;     
       }    
    }//end of convertToString()
    
   
    //Convert String recieved from file to type Shapes
    public Shapes convertToShape(String s){
        Shapes shape = new Shapes("", 0, 0, 0, 0); 
        String temp=null;
        
        //System.out.println("This string was retrieved from the file on server: " + s); //testing
        
        
        String [] result = s.trim().split(":");  
        int stringLength = result.length;
        int count = 0; //keep track of the location in the array of strings
        String type =result[count++]; //this returns the type of the shape eg. rectangle
        shape.setShapeType(type);
        
        //remove all the white space before and after the string
        for(int i=0; i<stringLength;i++){
            result[i]=result[i].trim();
            System.out.println("elements of a line: " + result[i]); //testing
        }
        
        if(type.equals("Ellipse")){
            String x = result[count];  count=count+1;
            String y = result[count];  count=count+1;
            String w = result[count];  count=count+1;
            String h = result[count];  count=count+1;
            String lRed = result[count];  count=count+1;
            String lGreen = result[count];  count=count+1;
            String lBlue = result[count];  count=count+1;
            String fRed = result[count];  count=count+1;
            String fGreen = result[count];  count=count+1;
            String fBlue = result[count];  count=count+1;
            String selected = result[count++];
            //Do the String to boolean conversion
            boolean b = Boolean.parseBoolean(selected);
            String id = result[count++];
            String name = result[count++];
            boolean locked = Boolean.parseBoolean(result[count++]);

            //System.out.println("element "+count+" "+result[count]);
            shape.setObjectSelected(b);
            shape.setStartCoordinates(Integer.parseInt(x), Integer.parseInt(y));  
            shape.setWidthHeight(Integer.parseInt(w), Integer.parseInt(h));

            Color lc = new Color(Integer.parseInt(lRed),Integer.parseInt(lGreen),Integer.parseInt(lBlue));
            shape.setLineColor(lc);
            Color fc = new Color(Integer.parseInt(fRed),Integer.parseInt(fGreen),Integer.parseInt(fBlue));
            shape.setfillColor(fc);
            shape.setShapeID(id);
            shape.setLock(locked);
            shape.setUsername(name);
            return shape;
        } else if (type.equals("Circle")){
            String x = result[count];  count=count+1;
            String y = result[count];  count=count+1;
            String w = result[count];  count++;
            String h = result[count];  count++;
            String lRed = result[count];  count++;
            String lGreen = result[count];  count++;
            String lBlue = result[count];  count++;
            String fRed = result[count];  count++;
            String fGreen = result[count];  count++;
            String fBlue = result[count];  count++;
            String selected = result[count++];
            //Do the String to boolean conversion
            boolean b = Boolean.parseBoolean(selected);
            String id = result[count++];
            String name = result[count++];
            boolean locked = Boolean.parseBoolean(result[count++]);

            //System.out.println("element "+count+" "+result[count]);
            shape.setObjectSelected(b);
            shape.setStartCoordinates(Integer.parseInt(x), Integer.parseInt(y));  
            shape.setWidthHeight(Integer.parseInt(w), Integer.parseInt(w));

            Color lc = new Color(Integer.parseInt(lRed),Integer.parseInt(lGreen),Integer.parseInt(lBlue));
            shape.setLineColor(lc);
            Color fc = new Color(Integer.parseInt(fRed),Integer.parseInt(fGreen),Integer.parseInt(fBlue));
            shape.setfillColor(fc);
            shape.setShapeID(id);
            shape.setLock(locked);
            shape.setUsername(name);
            return shape;
        } else if (type.equals("Line")){
            String x1 = result[count];  count=count+1;
            String y1 = result[count];  count=count+1;
            String x2 = result[count];  count=count+1;
            String y2 = result[count];  count=count+1;
            String lRed = result[count];  count=count+1;
            String lGreen = result[count];  count=count+1;
            String lBlue = result[count];  count=count+1;
            String selected = result[count++];
            //Do the String to boolean conversion
            boolean b = Boolean.parseBoolean(selected);
            String id = result[count++];
            String name = result[count++];
            boolean locked = Boolean.parseBoolean(result[count++]);

            //System.out.println("element "+count+" "+result[count]);
            shape.setObjectSelected(b);
            
            shape.setStartCoordinates(Integer.parseInt(x1), Integer.parseInt(y1));  
            shape.setEndCoordinates(Integer.parseInt(x2), Integer.parseInt(y2));
            Color lc = new Color(Integer.parseInt(lRed),Integer.parseInt(lGreen),Integer.parseInt(lBlue));
            shape.setLineColor(lc);
            shape.setShapeID(id);
            shape.setLock(locked);
            shape.setUsername(name);

            return shape;
        } else if (type.equals("Arrow")){
            String x1 = result[count];  count++;
            String y1 = result[count];  count++;
            String x2 = result[count];  count++;
            String y2 = result[count];  count++;
            String lRed = result[count];  count++;
            String lGreen = result[count];  count++;
            String lBlue = result[count];  count++;
            String selected = result[count++];
            //Do the String to boolean conversion
            boolean b = Boolean.parseBoolean(selected);
            String id = result[count++];
            String name = result[count++];
            boolean locked = Boolean.parseBoolean(result[count++]);

            //System.out.println("element "+count+" "+result[count]);
            shape.setObjectSelected(b);

            shape.setStartCoordinates(Integer.parseInt(x1), Integer.parseInt(y1));  
            shape.setEndCoordinates(Integer.parseInt(x2), Integer.parseInt(y2));
            Color lc = new Color(Integer.parseInt(lRed),Integer.parseInt(lGreen),Integer.parseInt(lBlue));
            shape.setLineColor(lc);
            shape.setShapeID(id);
            shape.setLock(locked);
            shape.setUsername(name);

            return shape; 
        } else if (type.equals("Rectangle")){
            String x = result[count];  count++;
            String y = result[count];  count++;
            String w = result[count];  count++;
            String h = result[count];  count++;
            String lRed = result[count];  count++;
            String lGreen = result[count];  count++;
            String lBlue = result[count];  count++;
            String fRed = result[count];  count++;
            String fGreen = result[count];  count++;
            String fBlue = result[count];  count++;
            String selected = result[count++];
            //Do the String to boolean conversion
            boolean b = Boolean.parseBoolean(selected);
            String id = result[count++];
            String name = result[count++];
            boolean locked = Boolean.parseBoolean(result[count++]);

            //System.out.println("element "+count+" "+result[count]);
            shape.setObjectSelected(b);
            
            shape.setStartCoordinates(Integer.parseInt(x), Integer.parseInt(y));  
            shape.setWidthHeight(Integer.parseInt(w), Integer.parseInt(h)); 
            Color lc = new Color(Integer.parseInt(lRed),Integer.parseInt(lGreen),Integer.parseInt(lBlue));
            shape.setLineColor(lc);
            Color fc = new Color(Integer.parseInt(fRed),Integer.parseInt(fGreen),Integer.parseInt(fBlue));
            shape.setfillColor(fc);
            shape.setShapeID(id);
            shape.setLock(locked);
            shape.setUsername(name);

            return shape;      
        } else if (type.equals("Round Rectangle")){
            String x = result[count];  count++;
            String y = result[count];  count++;
            String w = result[count];  count++;
            String h = result[count];  count++;
            String lRed = result[count];  count++;
            String lGreen = result[count];  count++;
            String lBlue = result[count];  count++;
            String fRed = result[count];  count++;
            String fGreen = result[count];  count++;
            String fBlue = result[count];  count++;
            String selected = result[count++];
            //Do the String to boolean conversion
            boolean b = Boolean.parseBoolean(selected);
            String id = result[count++];
            String name = result[count++];
            boolean locked = Boolean.parseBoolean(result[count++]);

            //System.out.println("element "+count+" "+result[count]);
            shape.setObjectSelected(b);
            
            shape.setStartCoordinates(Integer.parseInt(x), Integer.parseInt(y));  
            shape.setWidthHeight(Integer.parseInt(w), Integer.parseInt(h));
            Color lc = new Color(Integer.parseInt(lRed),Integer.parseInt(lGreen),Integer.parseInt(lBlue));
            shape.setLineColor(lc);
            Color fc = new Color(Integer.parseInt(fRed),Integer.parseInt(fGreen),Integer.parseInt(fBlue));
            shape.setfillColor(fc);
            shape.setShapeID(id);
            shape.setLock(locked);
            shape.setUsername(name);

            return shape;
            
        }
             System.out.println("Error has occured");           
        return null;
    }
    
}
