package slydez;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.lang.Object.*;
import java.applet.*;
import javax.swing.JPopupMenu;
import java.lang.Math.*;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.*;

import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;
//import engine.*;
import java.util.Timer;
import java.util.TimerTask;


public class WorkSpace extends JPanel implements ActionListener, MouseListener, MouseMotionListener {
    

    public int xpos, ypos; //The X-coordinate and Y-coordinate of the last click
    public int xDrag, yDrag; //Dragged coordinates
    public int xClick, yClick; //stores the coordinates of a mouse click
    public int xRelease, yRelease; //stores the coordinates of a mouse release
    public int width, height;
    boolean mouseEntered; //true if mouse has entered the workSpace area
    boolean clicked=true; //Flag for when mouse is clicked
    boolean dragged=false; //flag for when mouse is dragged
    boolean leftClick, rightClick;
    
    boolean resistorPressed = false;
    boolean rectanglePressed = false;
    boolean circlePressed = false;
    boolean linePressed = false;
    boolean ellipsePressed = false;
    boolean arrowPressed = false;
    boolean roundRectanglePressed = false;

    int startingX, startingY;
    
    public Shapes tempShape;  
    public ArrayList<Shapes> ShapeList;   
    
    static Color selectedColor = new Color(191,27,15) ; 
    
    public double ellipseCenterX; 
    public double ellipseCenterY;
    public double circleCenterX;
    public double circleCenterY;
    
    //Set the thickness of shape borders
    final static BasicStroke stroke = new BasicStroke(1.5f); 
    final static BasicStroke wideStroke = new BasicStroke(4.0f); //thickness when selected

    final static float dash1[] = {10.0f};
    final static BasicStroke dashed = new BasicStroke(4.0f, BasicStroke.CAP_BUTT,  BasicStroke.JOIN_MITER, 10.0f, dash1, 0.0f);
    
    boolean selected = false; //true if a shape has been selected
    
    String currentFileName;  
    String userName="john"; 
    int lastLineRead = 0; 
    int shapeCount = 0;

    //Graphics2D G2;
 
    public WorkSpace(){ 
       ShapeList = new ArrayList<Shapes>();
       setBackground(Color.BLACK);
       addMouseListener(this);
       addMouseMotionListener(this);  
       
       //Create instance of thread
 
 
    }
    
    public void setCurrentFileName(String fileName){
        currentFileName = fileName;
    }
    
    //************************************************Mouse Detection*************************************************//
    
    
    //Invoked when a mouse button has been pressed on a component
    public void mousePressed(MouseEvent e) {
        // Save the coordinates of the click 
        xpos = e.getX(); 
        ypos = e.getY(); 
        
        Cursor newCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
        setCursor(newCursor);
        
        //select(xClick, yClick);
           
        //Determine which mouse button has been pressed right, left, or middle
        if (e.isMetaDown()) {
            System.out.println ("Right mouse button pressed");
            
            if(e.isPopupTrigger()){
                popupMenu(e.getComponent(), e.getX(), e.getY());
            }
        } else if (e.isAltDown()) {
            System.out.println ("Middle mouse button pressed");
        } else {
            System.out.println ("Left mouse button pressed");
        }

    }  
    

    //Invoked when a mouse button has been released on a component
    public void mouseReleased(MouseEvent e) {
        dragged = false;        
        Cursor newCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        setCursor(newCursor);

        addShape();
        
    	repaint();
    }
    
    public void addShape(){
        String type = "";
	Shapes shape = new Shapes("", startingX, startingY, width, height);
	if(rectanglePressed)
            type = "Rectangle";
        else if(circlePressed){
		type = "Circle";
                shape.setCenterX(circleCenterX);
                shape.setCenterY(circleCenterY);
        }
        else if(linePressed){
            	type = "Line";
		shape.setEndCoordinates(xDrag, yDrag);
        }
        else if(ellipsePressed){
		type = "Ellipse";
                shape.setCenterX(ellipseCenterX);
                shape.setCenterY(ellipseCenterY);
        }
        else if(arrowPressed){
		type = "Arrow";
		shape.setEndCoordinates(xDrag, yDrag);
        }
        else if(roundRectanglePressed)
		type = "Round Rectangle";
        
        System.out.println("startx" + shape.getXCordStart() + " endx" + shape.getXCordEnd() + " starty" + shape.getYCordStart() + " endy" + shape.getYCordEnd()+ " centerX" + shape.getCenterX()+" centerY" + shape.getCenterY());
        
        
        if(!type.equals("") && startingX!=0 && startingY!=0 && xDrag!=0 && yDrag!=0){  
            //add the shape to the arrayList
            shape.setShapeType(type);
            shape.setShapeID((userName+shapeCount));
            shapeCount++; //increment the shape count
            ShapeList.add(shape);   
            shape.setSaved(true);
            //saveToServerEndOfFile(shape);
            
 
  
            
            deselect();

          
        }
	xDrag=0; yDrag=0; startingX = 0; startingY = 0; width = 0; height = 0;
    }
    
    
    //Invoked when the mouse button has been clicked (pressed and released)
    public void mouseClicked(MouseEvent e) {
        xClick = e.getX();
        yClick = e.getY(); 
        
        //if mouse is click selected will be set to false
        selected=false;         
        //check if the location of the click is on a shape, if so select and set selected to true
        select(e.getX(), e.getY());

    }
    
    
    //Invoked when the mouse enters a component
    public void mouseEntered(MouseEvent e) {
        mouseEntered = true; 
        Cursor newCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        setCursor(newCursor);
    }
    
   
    //Invoked when the mouse exits a component
    public void mouseExited(MouseEvent e) {
        mouseEntered = false; 
    }
    
  
    //Invoked when the mouse is moved
    public void mouseMoved(MouseEvent e) {
        Cursor newCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        setCursor(newCursor);
        
        //should cancel the timer everytime the mouse is moved 
        //System.out.println("mouse position" + e.getLocationOnScreen());

    }
    
    
    
 
    //Invoked when the mouse is moved while 
    public void mouseDragged(MouseEvent e) {
        dragged =true;
        Cursor newCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
        setCursor(newCursor);
        
        xDrag = e.getX();
        yDrag = e.getY(); 
        startingX = xpos;
        startingY = ypos;
        
        if(!linePressed && !arrowPressed){
        if(xpos<xDrag)
            width = xDrag-xpos;
        if(xpos>xDrag){
            width = xpos-xDrag;
            startingX = xDrag;  
        }
        if(ypos<yDrag)
            height = yDrag-ypos;
        if(ypos>yDrag){
            height = ypos-yDrag;
            startingY = yDrag;  
        }
        if(xpos>xDrag && ypos<yDrag)
            startingY = ypos;
        }
        repaint();
    }    
    
    
    //***************************************Mouse Features Implemented**************************************//
    

    public void popupMenu(Component c, int x, int y){
        JMenuItem menuItem;
        
        //Create the popup menu.
        JPopupMenu popup = new JPopupMenu();
        menuItem = new JMenuItem("Cut");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Copy");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Paste");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Delete");
        menuItem.addActionListener(this);
        popup.add(menuItem);

        //Add listener to components that can bring up popup menus.
        //MouseListener popupListener = new PopupListener();
        //addMouseListener(popupListener);

        popup.show(c, x, y);

        repaint();
    }
    
    public void actionPerformed(ActionEvent e) {
      
        String commandName = e.getActionCommand();
        
        if(commandName.equals("Cut")){
            //perform Cut operation
        } else if (commandName.equals("Copy")) {
            //perform Copy operation
        } else if (commandName.equals("Paste")) {
            //perdorm Paste operation
        } else if (commandName.equals("Delete")) {
            //perdorm Paste operation
        } 
    }
    
    //****************************************Implementation of Shapes********************************************// 
   
    public void resistorPressed(){
        resistorPressed = true;
        ellipsePressed = true; 
        arrowPressed = false;
        rectanglePressed = false;
        circlePressed = false;
        linePressed = false;
        roundRectanglePressed = false; 
    }
    
    
    //Ellipse has been selected and all others deselected
    public void ellipsePressed(){
        ellipsePressed = true; 
        arrowPressed = false;
        rectanglePressed = false;
        circlePressed = false;
        linePressed = false;
        roundRectanglePressed = false; 
    }
    
   
    public void drawEllipse(Graphics2D g2, Shapes s){
      
        int x = s.getXCordStart();
        int y = s.getYCordStart();
        int w = s.getWidth();
        int h = s.getHeight();   
        //String c = s.getLineColor(); //get the shape color
           
        //draw Ellipse2D.Double
        //g2.setColor(Color.red);//getColor(c));
        g2.setColor(s.getLineColor()); //retrieve the line color from shape
        
        //if shape has been selected apply wide border else apply regular border
        if(s.getObjectSelected()){
            //g2.setStroke(wideStroke);
            g2.setStroke(dashed);
        }else{
            g2.setStroke(stroke);
        }
        
        Ellipse2D ellipse = new Ellipse2D.Double(x, y, w, h);
        ellipseCenterX = ellipse.getCenterX();
        ellipseCenterY = ellipse.getCenterY();
        g2.draw(ellipse);
        g2.setColor(s.getFillColor()); //retrieve the line color from shape
        g2.fill(ellipse); //draw shapw with specified fill color
    }
    
    
    //circle has been selected and all others have been deselected
    public void circlePressed(){
	circlePressed = true;
        arrowPressed = false;
        rectanglePressed = false;
        linePressed = false;
        ellipsePressed = false;
        roundRectanglePressed = false;	
    } 
    
   
    public void drawCircle(Graphics2D g2, Shapes s){
       
        int x = s.getXCordStart();
        int y = s.getYCordStart();
        int w = s.getWidth();
        //String c = s.getLineColor();
        
        //draw Ellipse2D.Double
        //g2.setColor(Color.green);//getColor(c));
        g2.setColor(s.getLineColor()); //retrieve the line color from shape
           
        //if shape has been selected apply wide border else apply regular border
        if(s.getObjectSelected()){
            //g2.setStroke(wideStroke);
            g2.setStroke(dashed);
        }else{
            g2.setStroke(stroke);
        }        
        
        Ellipse2D circle = new Ellipse2D.Double(x, y, w, w);
        circleCenterX = circle.getCenterX();
        circleCenterY = circle.getCenterY();
        g2.draw(circle);
        g2.setColor(s.getFillColor()); //retrieve the line color from shape
        g2.fill(circle); //draw shapw with specified fill color  
        /*g2.setColor(Color.RED);
        //Ellipse2D circle = new Ellipse2D.Double(xpos, ypos, width, width);
        Ellipse2D circle2 = new Ellipse2D.Double(startingX, startingY, width+50, width);
        g2.draw(circle2);      */  
    }
    
  
    //line has been selected and all others have been deselected
    public void linePressed(){
        linePressed = true;
        arrowPressed = false;
        rectanglePressed = false;
        circlePressed = false;
        ellipsePressed = false;
        roundRectanglePressed = false;      
    }
    
  
    public void drawLine(Graphics2D g2, Shapes s){
         
        int x1 = s.getXCordStart();
        int y1 = s.getYCordStart();
        int x2 = s.getXCordEnd();
        int y2 = s.getYCordEnd();
        //String c = s.getLineColor();
        
        //draw Ellipse2D.Double
        //g2.setColor(Color.blue);//getColor(c));  
        g2.setColor(s.getLineColor()); //retrieve the line color from shape
        
        //if shape has been selected apply wide border else apply regular border
        if(s.getObjectSelected()){
            //g2.setStroke(wideStroke);
            g2.setStroke(dashed);
        }else{
            g2.setStroke(stroke);
        }
        
        Line2D line = new Line2D.Float(x1, y1, x2, y2);
        g2.draw(line);
    }
    
   
    //line has been selected and all others have been deselected
    public void arrowPressed(){
    	arrowPressed = true;
        roundRectanglePressed = false;
        rectanglePressed = false;
        circlePressed = false;
        linePressed = false;
        ellipsePressed = false;        
    }
    
   
    //Used to draw arrow
    //Return the y-coordinate for the arrow head
    private static int yCor(int len, double dir) {
        return (int)(len * Math.cos(dir));
    }
    
  
    //Used to draw arrow
    //Return the x-coordinate for the arrow head
    private static int xCor(int len, double dir) {
        return (int)(len * Math.sin(dir));
    }
    
  
    public void drawArrow(Graphics2D g2, Shapes s){
        
        int x1 = s.getXCordStart();
        int y1 = s.getYCordStart();
        int x2 = s.getXCordEnd();
        int y2 = s.getYCordEnd();
        //String c = s.getLineColor();
            
        double stroke1 = 1.5;
        double aDir = Math.atan2(x1-x2, y1-y2);
        int i1 = 12 + (int)(stroke1*2);
        int i2 = 6 + (int)stroke1;	// make the arrow head the same size regardless of the length 

        //if shape has been selected apply wide border else apply regular border
        if(s.getObjectSelected()){
            //g2.setStroke(wideStroke);
            g2.setStroke(dashed);
        }else{
            g2.setStroke(stroke);
        }
        
        //draw arrow Double
        g2.setColor(s.getLineColor()); //retrieve the line color from shape
        g2.drawLine(x1, y1, x2, y2);
        //g2.setStroke(new BasicStroke(2f));	// make the arrow head solid even if dash pattern has been specified
        
        Polygon tmpPoly = new Polygon();    
        tmpPoly.addPoint(x2, y2);	// arrow tip
        tmpPoly.addPoint(x2 + xCor(i1,aDir+.5), y2 + yCor(i1, aDir + .5));
        tmpPoly.addPoint(x2 + xCor(i2,aDir), y2 + yCor(i2, aDir));
        tmpPoly.addPoint(x2 + xCor(i1,aDir-.5), y2 + yCor(i1, aDir-.5));
        tmpPoly.addPoint(x2, y2);	// arrow tip
        
        g2.setStroke(stroke);
        g2.drawPolygon(tmpPoly);
        g2.fillPolygon(tmpPoly);	
    }
    
 
    public void rectanglePressed(){
	rectanglePressed = true;
        circlePressed = false;
        linePressed = false;
        ellipsePressed = false;
        roundRectanglePressed = false;
        arrowPressed = false;
    }
    
 
    public void drawRectangle(Graphics2D g2, Shapes s) {    
 
        int x = s.getXCordStart();
        int y = s.getYCordStart();
        int w = s.getWidth();
        int h = s.getHeight();
        
        //System.out.println("startx" + x + "endx" + s.getXCordEnd() + "starty" + y + "endy" + s.getYCordEnd());

        g2.setColor(s.getLineColor()); //retrieve the line color from shape
        Rectangle2D rect = new Rectangle2D.Float(x, y, w, h);

        //if shape has been selected apply wide border else apply regular border
        if(s.getObjectSelected()){
            //g2.setStroke(wideStroke);
            g2.setStroke(dashed);
        }else{
            g2.setStroke(stroke);
        }
        g2.draw(rect); //draw shapw with specified border color
        g2.setColor(s.getFillColor()); //retrieve the line color from shape
        g2.fill(rect); //draw shapw with specified fill color
    }   
    
 
    public void roundRectanglePressed(){	
        roundRectanglePressed = true;
        rectanglePressed = false;
        circlePressed = false;
        linePressed = false;
        ellipsePressed = false;
        arrowPressed = false;	
    }
    
 
    public void drawRoundRectangle(Graphics2D g2, Shapes s) {    

        int x = s.getXCordStart();
        int y = s.getYCordStart();
        int w = s.getWidth();
        int h = s.getHeight();
        int a = s.getArc();
        //String c = s.getLineColor();
        
        g2.setColor(s.getLineColor()); //retrieve the line color from shape
        RoundRectangle2D roundRect = new RoundRectangle2D.Float(x, y, w, h, a, a);
        
        if(s.getObjectSelected()){
            //g2.setStroke(wideStroke);
            g2.setStroke(dashed);
        }else{
            g2.setStroke(stroke);
        }
        g2.draw(roundRect); //draw shapw with specified border color
        g2.setColor(s.getFillColor()); //retrieve the line color from shape
        g2.fill(roundRect); //draw shapw with specified fill color    
    }
    
 
    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        
        //Background color
        g2.setColor(Color.darkGray);
        Rectangle2D rect = new Rectangle2D.Float(0, 0,this.getWidth(), this.getHeight());        
        g2.fill(rect);
        
        //WorkSpace Color
        g2.setColor(Color.WHITE);
        Rectangle2D rect2 = new Rectangle2D.Float(5, 5,this.getWidth()-10, this.getHeight()-10);        
        g2.fill(rect2);
        
        Iterator iter = ShapeList.iterator();
        //Draw the shapes in the ArrayList (ShapeList)
        while(iter.hasNext()){
                //Retrieve the next shape from the ShapeList     
            Shapes tempShape = (Shapes)iter.next();
            System.out.println(tempShape.getShapeType());
            
            if (tempShape.getShapeType().equals("Rectangle")){
                drawRectangle(g2, tempShape); 
            } else if (tempShape.getShapeType().equals("Round Rectangle")){
                drawRoundRectangle(g2, tempShape); 
            } else if (tempShape.getShapeType().equals("Circle")){
                drawCircle(g2, tempShape); 
            } else if (tempShape.getShapeType().equals("Ellipse")){
                drawEllipse(g2, tempShape); 
            } else if (tempShape.getShapeType().equals("Line")){
                drawLine(g2, tempShape);
            } else if (tempShape.getShapeType().equals("Arrow")){
                drawArrow(g2, tempShape);
            } 
        }  //end of while
        //Shape is visible while dragging - temperary shape
        if(dragged){
            if(rectanglePressed)
                drawRectangle(g2, new Shapes("Rectangle", startingX, startingY, width, height));
            else if(circlePressed)
                    drawCircle(g2, new Shapes("Circle", startingX, startingY, width, height));
            else if(ellipsePressed)
                    drawEllipse(g2, new Shapes("Circle", startingX, startingY, width, height));             
            else if(linePressed){
                    Shapes s = new Shapes("Line", startingX, startingY, 0, 0);
                    s.setEndCoordinates(xDrag, yDrag);
                    drawLine(g2, s);
            }
            else if(arrowPressed){
                    Shapes s = new Shapes("Arrow", startingX, startingY, 0, 0);
                    s.setEndCoordinates(xDrag, yDrag);
                    drawArrow(g2, s);
            }        
            else if(roundRectanglePressed){
                    Shapes s = new Shapes("Round Rectangle", startingX, startingY, width, height);
                    drawRoundRectangle(g2, s);
            }
        } //end of if statement
        
        
        
        setOpaque(false);
        System.out.println(ShapeList.size());
    }
    
  
    //check if a shape has been selected
    public void select (int x, int y){

        selected=false;
        deselect(); //deselect a current shape
        
        //loop through the ShapeList backwards (from last element to first)
        for (int listSize=ShapeList.size()-1; listSize >= 0; listSize--){
            
            //Retrieve the next shape from the ShapeList     
            Shapes tempShape = ShapeList.get(listSize);
            
            if (tempShape.getShapeType().equals("Rectangle")){
                 //check if the click position is within the bounds of a rectangle
                 if ((y > tempShape.getYCordStart()) && (y < (tempShape.getHeight()+tempShape.getYCordStart()) ) && 
                     (x > tempShape.getXCordStart()) && (x < (tempShape.getWidth()+tempShape.getXCordStart()) )){
                    
                     System.out.println("Select Circle"); //testing...
                     tempShape.setObjectSelected(true);
                     tempShape.setUsername(userName);
                     selected=true;
                     
                     if(tempShape.getObjectSelected()){
                         //tempShape.setLineColor(selectedColor); //make border 
                         //ShapeList.set(listSize, tempShape);
                         ShapeList.remove(listSize);
                         ShapeList.add(listSize, tempShape);
 
                         break;
                     }
                 }
            } else if (tempShape.getShapeType().equals("Round Rectangle")){ 
                 //check if the click position is within the bounds of a rectangle
                 if ((y > tempShape.getYCordStart()) && (y < (tempShape.getHeight()+tempShape.getYCordStart()) ) && 
                     (x > tempShape.getXCordStart()) && (x < (tempShape.getWidth()+tempShape.getXCordStart()) )){

                     tempShape.setObjectSelected(true);
                     tempShape.setUsername(userName);
                     selected=true;
                     
                     if(tempShape.getObjectSelected()){
                         //tempShape.setLineColor(selectedColor); //make border 
                         ShapeList.set(listSize, tempShape);
    
                         break;
                     }
                 }                
            } else if (tempShape.getShapeType().equals("Circle")){
                
             
                
                double c1 =/* ( tempShape.getCenterX()); */tempShape.getXCordStart()+ (tempShape.getWidth()/2); //x-coordinate of the centre of the circle
                double c2 =/* ( tempShape.getCenterY()); */tempShape.getYCordStart()+ (tempShape.getWidth()/2); //y-coordinate of the center of the circle
                double a = tempShape.getCenterX()+c1;//( Math.abs(tempShape.getXCordEnd()-tempShape.getXCordStart()) )/2;
                double b = tempShape.getCenterY()+c2;//( Math.abs(tempShape.getYCordEnd()-tempShape.getYCordStart()) )/2;
                
                System.out.println("a " + a +  "b " + b + "c1 "+ c1 + "c2 " + c2);
                double insideCircle = ( ((x-c1)*(x-c1))/(a*a) ) + ( ((y-c2)*(y-c2))/(b*b) );
                System.out.println("Circle result" + insideCircle); //testing...
                
                if (insideCircle <= 1){                  
                    tempShape.setObjectSelected(true);
                    tempShape.setUsername(userName);
                    selected=true;
                     System.out.println("Select Circle"); //testing...

                     if(tempShape.getObjectSelected()){
                         //tempShape.setLineColor(selectedColor); //make border 
                         ShapeList.set(listSize, tempShape);
    
                         break;
                     }
                }

            } else if (tempShape.getShapeType().equals("Ellipse")){
                //(x_0, y_0) is inside the ellipse if 
                //(x_0-c_1)^2 / a^2 + (y_0`-c_2)^2 / b^2 = 1 
                //where a = |x_2-x_1|/2 and b=|y_2-y_1|/2 
                //where c_1 and c_2 are the coordinates of the center of the circle
                double a = ( Math.abs(tempShape.getXCordEnd()-tempShape.getXCordStart()) )/2;
                double b = ( Math.abs(tempShape.getYCordEnd()-tempShape.getYCordStart()) )/2;
                double c1 = ( tempShape.getCenterX());//tempShape.getXCordStart()+ (tempShape.getWidth()/2) ); //x-coordinate of the centre of the circle
                double c2 = ( tempShape.getCenterY());//tempShape.getYCordStart()+ (tempShape.getHeight()/2) ); //y-coordinate of the center of the circle
                
                double insideEllipse = (((x-c1)*(x-c1))/(a*a)) + (((y-c2)*(y-c2))/(b*b));
                System.out.println("Ellipse result" + insideEllipse); //testing...
                
                if (insideEllipse <= 1){
                     tempShape.setObjectSelected(true);
                     tempShape.setUsername(userName);
                     selected=true;
                     System.out.println("Select Ellipse"); //testing...
 
                     if(tempShape.getObjectSelected()){
                         //tempShape.setLineColor(selectedColor); //make border 
                         ShapeList.set(listSize, tempShape);
  
                         break;
                     }
                }                

            } else if (tempShape.getShapeType().equals("Line")){
                
                //dstance from (x1,y1) to (x2,y2)=sqrt( (x1-x2)^2 + (y1-y2)^2 ) 
                //length of line segment
                double lineLength = Math.sqrt((double)( ((tempShape.getXCordEnd()-tempShape.getXCordStart())*(tempShape.getXCordEnd()-tempShape.getXCordStart())) +
                                                       ((tempShape.getYCordEnd()-tempShape.getYCordStart())*(tempShape.getYCordEnd()-tempShape.getYCordStart())) )); 
                //Distance from the clicked coordinates to (x1,y1) of the line segment
                double d1 = Math.sqrt((double)( ((tempShape.getXCordEnd()-x)*(tempShape.getXCordEnd()-x)) +
                                                       ((tempShape.getYCordEnd()-y)*(tempShape.getYCordEnd()-y)) )); 
                //Distance from the clicked coordinates to (x2,y2) of the line segment
                double d2 = Math.sqrt((double)( ((x-tempShape.getXCordStart())*(x-tempShape.getXCordStart())) +
                                                       ((y-tempShape.getYCordStart())*(y-tempShape.getYCordStart())) )); 
                //sum of the clicked coordinates to the startng point of line segment and end of line segment
                double sumD1D2 = d1 + d2;
                
                //if length of line segment and the sum of the distance 
                //of the click to the line segment are equal
                if(sumD1D2<=(lineLength+0.25)){
                    tempShape.setObjectSelected(true);
                    tempShape.setUsername(userName);
                    selected=true;
                    System.out.println("Select"); //testing...
                    if(tempShape.getObjectSelected()){
                        //tempShape.setLineColor(selectedColor); //make border 
                        ShapeList.set(listSize, tempShape);
  
                        break;
                    }   
                } 
            } else if (tempShape.getShapeType().equals("Arrow")){
                //dstance from (x1,y1) to (x2,y2)=sqrt( (x1-x2)^2 + (y1-y2)^2 ) 
                //length of line segment
                double arrowLength = Math.sqrt((double)( ((tempShape.getXCordEnd()-tempShape.getXCordStart())*(tempShape.getXCordEnd()-tempShape.getXCordStart())) +
                                                       ((tempShape.getYCordEnd()-tempShape.getYCordStart())*(tempShape.getYCordEnd()-tempShape.getYCordStart())) )); 
                //Distance from the clicked coordinates to (x1,y1) of the line segment
                double d1 = Math.sqrt((double)( ((tempShape.getXCordEnd()-x)*(tempShape.getXCordEnd()-x)) +
                                                       ((tempShape.getYCordEnd()-y)*(tempShape.getYCordEnd()-y)) )); 
                //Distance from the clicked coordinates to (x2,y2) of the line segment
                double d2 = Math.sqrt((double)( ((x-tempShape.getXCordStart())*(x-tempShape.getXCordStart())) +
                                                       ((y-tempShape.getYCordStart())*(y-tempShape.getYCordStart())) )); 
                //sum of the clicked coordinates to the startng point of line segment and end of line segment
                double sumD1D2 = d1 + d2;
                
                //if length of line segment and the sum of the distance 
                //of the click to the line segment are equal
                if((arrowLength+.25)>=sumD1D2){
                    tempShape.setObjectSelected(true);
                    tempShape.setUsername(userName);
                    selected=true;
                    System.out.println("Select"); //testing...
                    if(tempShape.getObjectSelected()){
                        //tempShape.setLineColor(selectedColor); //make border 
                        ShapeList.set(listSize, tempShape);
    
                        break;
                    }   
                } 
            } //end of if statement
	}  //end of while
    } //end of select()
    
    
  
    public void deselect(){
        
        //loop through the ShapeList backwards (from last element to first)
        for (int listSize=ShapeList.size()-1; listSize >= 0; listSize--){
            
            //Retrieve the next shape from the ShapeList     
            Shapes tempShape = ShapeList.get(listSize);
            
            if (tempShape.getObjectSelected()){
                tempShape.setObjectSelected(false); //set the select to false
                ShapeList.set(listSize, tempShape); //resave the shape int the arrayList
     
                
                selected=false;
                
                //deselectTimer.start();
            }
        } 
        repaint();
    }
    
    public int indexOfSelected(){
        int listSize;
        
        //loop through the ShapeList backwards (from last element to first)
        for (listSize=ShapeList.size()-1; listSize >= 0; listSize--){
            
            //Retrieve the next shape from the ShapeList     
            Shapes tempShape = ShapeList.get(listSize);
            
            if (tempShape.getObjectSelected()){
                tempShape.setObjectSelected(false); //set the select to false
                ShapeList.set(listSize, tempShape); //resave the shape int the arrayList
      
                   
                break;
                //deselectTimer.start();
            }
        } 
        return listSize;
    }
    
 
    
}
